<!DOCTYPE html>
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<title>Canvas Image Manipulation</title>
<style type="text/css">
	body {
		background-color: white;
	}
</style>
<script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.4.4/jquery.min.js"></script>
</head>

<body>
	<img id="mike-code-img" src="images/code.png" alt="Canvas Source" />
<!-- 	<img src="http://farm3.static.flickr.com/2481/5847766864_be4d998fe5_b.jpg" id="mike-code-img" /> -->

	<canvas id="mike-code-canvas" width="485" height="223"></canvas>
	
	<ul>
		<li><a href="#" data-color="white">Alter background color</a></li>
		<li><a href="#">No effect</a></li>
		<li><a href="#" data-pattern="jeans">Jeans</a></li>
		<li><a href="#" data-pattern="stripes">Stripes</a></li>
		<li><a href="#" data-pattern="noise">Noise</a></li>
		<li><a href="#" data-pattern="dots">Dots</a></li>
		<li><a href="#" data-pattern="opacity">Opacity</a></li>
		<li><a href="#" data-pattern="random">Random</a></li>
	</ul>
	
	<script type="text/javascript">
	
		function changePattern(pattern) {
			
			pattern = pattern || "jeans";
			
			
			
			var mikeCodeCanvas = document.getElementById("mike-code-canvas");
			
			// remember to reset the canvas before placing a new effect on the image
			mikeCodeCanvas.width = mikeCodeCanvas.width;
			
			var mikeCodeContext = mikeCodeCanvas.getContext("2d");
			
			var mikeCodeImage = document.getElementById("mike-code-img");
						
			// draw the image
			mikeCodeContext.drawImage(mikeCodeImage, 0, 0);
			
			var mikeCodeImgData = mikeCodeContext.getImageData(0, 0, 485, 223);
			
			var mikeCodePix = mikeCodeImgData.data;
			
			for (var i = 0, n = mikeCodePix.length; i < n; i += 4) {
				var color = 255;
				
				if(mikeCodePix[i] > 0) {
					color = 0;
				}
				
				/*
mikeCodePix[i] = color; 	// red
				mikeCodePix[i+1] = color; 	// green
				mikeCodePix[i+2] = color; 	// blue
				
*/
				mikeCodePix[i] = 255 - mikeCodePix[i];
				mikeCodePix[i + 1] = 255 - mikeCodePix[i + 1];
				mikeCodePix[i + 2] = 255 - mikeCodePix[i + 2];
				// jeans
				if(pattern == "jeans") {
					mikeCodePix[i * 4 + 3] = Math.floor(Math.random()*256);					
				}

				
				// stripes
				if(pattern == "stripes") {
					mikeCodePix[i * 4 + 3] = 90;
				}
				//
				
				// noise
				if(pattern == "noise") {
					mikeCodePix[i * Math.floor(Math.random()*4) + 3] = Math.floor(Math.random()*256);
				}
				//
				
				// dots
				if(pattern == "dots") {
					mikeCodePix[i * 2 + 3] = 90;
				}
				//
				
				// straight opacity
				if(pattern == "opacity") {
					mikeCodePix[i + 3] = 90;
				}
				
				if(pattern == "random") {
					mikeCodePix[i + 3] = Math.floor(Math.random()*256);
				}
			}
			
			mikeCodeContext.clearRect(0, 0, mikeCodeCanvas.width, mikeCodeCanvas.height);
			mikeCodeContext.putImageData(mikeCodeImgData, 0, 0);
			console.debug("end");
		}
	
	
		$(document).ready(function () {
		
			$("li").click(function (event) {
				//console.debug($(event.currentTarget.childNodes).data().pattern);
				//console.dir($(event.currentTarget).find("a").data());
				
				if($(event.currentTarget).find("a").data().pattern) {
					var pattern = $(event.currentTarget).find("a").data().pattern
					changePattern(pattern);
				}
				
				if($(event.currentTarget).find("a").data().color) {
					var color = $(event.currentTarget).find("a").data().color;
					
					$("body").css({"background-color" : color});
					if(color == "white") {
						color = "black";
					} else {
						color = "white";
					}
					$("a").data("color", color);
				}

			});
		});
		
		$(window).load(function () {
			changePattern("jeans");
		});

	</script>
	
</body>
</html>
